]> git.saurik.com Git - apt.git/blob - test/integration/framework
if the codename is "experimental" add NotAutomatic:yes by default
[apt.git] / test / integration / framework
1 #!/bin/sh -- # no runable script, just for vi
2
3 # we all like colorful messages
4 CERROR="\e[1;31m" # red
5 CWARNING="\e[1;33m" # yellow
6 CMSG="\e[1;32m" # green
7 CINFO="\e[1;96m" # light blue
8 CDEBUG="\e[1;94m" # blue
9 CNORMAL="\e[0;39m" # default system console color
10 CDONE="\e[1;32m" # green
11 CPASS="\e[1;32m" # green
12 CFAIL="\e[1;31m" # red
13 CCMD="\e[1;35m" # pink
14
15 msgdie() { echo "${CERROR}E: $1${CNORMAL}" >&2; exit 1; }
16 msgwarn() { echo "${CWARNING}W: $1${CNORMAL}" >&2; }
17 msgmsg() { echo "${CMSG}$1${CNORMAL}" >&2; }
18 msginfo() { echo "${CINFO}I: $1${CNORMAL}" >&2; }
19 msgdebug() { echo "${CDEBUG}D: $1${CNORMAL}" >&2; }
20 msgdone() { echo "${CDONE}DONE${CNORMAL}" >&2; }
21 msgnwarn() { echo -n "${CWARNING}W: $1${CNORMAL}" >&2; }
22 msgnmsg() { echo -n "${CMSG}$1${CNORMAL}" >&2; }
23 msgninfo() { echo -n "${CINFO}I: $1${CNORMAL}" >&2; }
24 msgndebug() { echo -n "${CDEBUG}D: $1${CNORMAL}" >&2; }
25 msgtest() { echo -n "${CINFO}$1 ${CCMD}$(echo "$2" | sed -e 's/^aptc/apt-c/' -e 's/^aptg/apt-g/' -e 's/^aptf/apt-f/')${CINFO} ${CNORMAL} " >&2; }
26 msgpass() { echo "${CPASS}PASS${CNORMAL}" >&2; }
27 msgskip() { echo "${CWARNING}SKIP${CNORMAL}" >&2; }
28 msgfail() { echo "${CFAIL}FAIL${CNORMAL}" >&2; }
29
30 # enable / disable Debugging
31 MSGLEVEL=${MSGLEVEL:-3}
32 if [ $MSGLEVEL -le 0 ]; then
33 msgdie() { true; }
34 fi
35 if [ $MSGLEVEL -le 1 ]; then
36 msgwarn() { true; }
37 msgnwarn() { true; }
38 fi
39 if [ $MSGLEVEL -le 2 ]; then
40 msgmsg() { true; }
41 msgnmsg() { true; }
42 fi
43 if [ $MSGLEVEL -le 3 ]; then
44 msginfo() { true; }
45 msgninfo() { true; }
46 fi
47 if [ $MSGLEVEL -le 4 ]; then
48 msgdebug() { true; }
49 msgndebug() { true; }
50 fi
51 msgdone() {
52 if [ "$1" = "debug" -a $MSGLEVEL -le 4 ] ||
53 [ "$1" = "info" -a $MSGLEVEL -le 3 ] ||
54 [ "$1" = "msg" -a $MSGLEVEL -le 2 ] ||
55 [ "$1" = "warn" -a $MSGLEVEL -le 1 ] ||
56 [ "$1" = "die" -a $MSGLEVEL -le 0 ]; then
57 true;
58 else
59 echo "${CDONE}DONE${CNORMAL}" >&2;
60 fi
61 }
62
63 runapt() {
64 msgdebug "Executing: ${CCMD}$*${CDEBUG} "
65 if [ -f ./aptconfig.conf ]; then
66 APT_CONFIG=aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
67 elif [ -f ../aptconfig.conf ]; then
68 APT_CONFIG=../aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
69 else
70 LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
71 fi
72 }
73 aptconfig() { runapt apt-config $*; }
74 aptcache() { runapt apt-cache $*; }
75 aptget() { runapt apt-get $*; }
76 aptftparchive() { runapt apt-ftparchive $*; }
77 aptkey() { runapt apt-key $*; }
78 dpkg() {
79 $(which dpkg) --root=${TMPWORKINGDIRECTORY}/rootdir --force-not-root --force-bad-path --log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log $*
80 }
81
82 setupenvironment() {
83 TMPWORKINGDIRECTORY=$(mktemp -d)
84 local TESTDIR=$(readlink -f $(dirname $0))
85 msgninfo "Preparing environment for ${CCMD}$(basename $0)${CINFO} in ${TMPWORKINGDIRECTORY}… "
86 BUILDDIRECTORY="${TESTDIR}/../../build/bin"
87 test -x "${BUILDDIRECTORY}/apt-get" || msgdie "You need to build tree first"
88 local OLDWORKINGDIRECTORY=$(pwd)
89 CURRENTTRAP="cd /; rm -rf $TMPWORKINGDIRECTORY; cd $OLDWORKINGDIRECTORY"
90 trap "$CURRENTTRAP" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
91 cd $TMPWORKINGDIRECTORY
92 mkdir rootdir aptarchive keys
93 cd rootdir
94 mkdir -p etc/apt/apt.conf.d etc/apt/sources.list.d etc/apt/trusted.gpg.d etc/apt/preferences.d
95 mkdir -p var/cache var/lib var/log
96 mkdir -p var/lib/dpkg/info var/lib/dpkg/updates var/lib/dpkg/triggers
97 local STATUSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/status-/' -e 's/^skip-/status-/')
98 if [ -f "${TESTDIR}/${STATUSFILE}" ]; then
99 cp "${TESTDIR}/${STATUSFILE}" var/lib/dpkg/status
100 else
101 touch var/lib/dpkg/status
102 fi
103 touch var/lib/dpkg/available
104 mkdir -p usr/lib/apt
105 ln -s ${BUILDDIRECTORY}/methods usr/lib/apt/methods
106 cd ..
107 local PACKAGESFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Packages-/' -e 's/^skip-/Packages-/')
108 if [ -f "${TESTDIR}/${PACKAGESFILE}" ]; then
109 cp "${TESTDIR}/${PACKAGESFILE}" aptarchive/Packages
110 else
111 touch aptarchive/Packages
112 fi
113 cp $(find $TESTDIR -name '*.pub' -o -name '*.sec') keys/
114 ln -s ${TMPWORKINGDIRECTORY}/keys/joesixpack.pub rootdir/etc/apt/trusted.gpg.d/joesixpack.gpg
115 echo "Dir \"${TMPWORKINGDIRECTORY}/rootdir\";" > aptconfig.conf
116 echo "Dir::state::status \"${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg/status\";" >> aptconfig.conf
117 echo "Debug::NoLocking \"true\";" >> aptconfig.conf
118 echo "APT::Get::Show-User-Simulation-Note \"false\";" >> aptconfig.conf
119 echo "Dir::Bin::dpkg \"fakeroot\";" >> aptconfig.conf
120 echo "DPKG::options:: \"dpkg\";" >> aptconfig.conf
121 echo "DPKG::options:: \"--root=${TMPWORKINGDIRECTORY}/rootdir\";" >> aptconfig.conf
122 echo "DPKG::options:: \"--force-not-root\";" >> aptconfig.conf
123 echo "DPKG::options:: \"--force-bad-path\";" >> aptconfig.conf
124 echo "DPKG::options:: \"--log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log\";" >> aptconfig.conf
125 export LC_ALL=C
126 msgdone "info"
127 }
128
129 configarchitecture() {
130 local CONFFILE=rootdir/etc/apt/apt.conf.d/01multiarch.conf
131 echo "APT::Architecture \"$1\";" > $CONFFILE
132 shift
133 while [ -n "$1" ]; do
134 echo "APT::Architectures:: \"$1\";" >> $CONFFILE
135 shift
136 done
137 }
138
139 setupsimplenativepackage() {
140 local NAME="$1"
141 local ARCH="$2"
142 local VERSION="$3"
143 local RELEASE="${4:-unstable}"
144 local DEPENDENCIES="$5"
145 local DESCRIPTION="$6"
146 local SECTION="${7:-others}"
147 local DISTSECTION
148 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
149 DISTSECTION="main"
150 else
151 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
152 fi
153 local BUILDDIR=incoming/${NAME}-${VERSION}
154 mkdir -p ${BUILDDIR}/debian/source
155 cd ${BUILDDIR}
156 echo "* most suckless software product ever" > FEATURES
157 test -e debian/copyright || echo "Copyleft by Joe Sixpack $(date +%Y)" > debian/copyright
158 test -e debian/changelog || echo "$NAME ($VERSION) $RELEASE; urgency=low
159
160 * Initial release
161
162 -- Joe Sixpack <joe@example.org> $(date -R)" > debian/changelog
163 test -e debian/control || echo "Source: $NAME
164 Section: $SECTION
165 Priority: optional
166 Maintainer: Joe Sixpack <joe@example.org>
167 Build-Depends: debhelper (>= 7)
168 Standards-Version: 3.9.1
169
170 Package: $NAME
171 Architecture: $ARCH" > debian/control
172 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> debian/control
173 if [ -z "$DESCRIPTION" ]; then
174 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
175 If you find such a package installed on your system,
176 YOU did something horribly wrong! They are autogenerated
177 und used only by testcases for APT and surf no other propose…" >> debian/control
178 else
179 echo "Description: $DESCRIPTION" >> debian/control
180 fi
181 test -e debian/compat || echo "7" > debian/compat
182 test -e debian/source/format || echo "3.0 (native)" > debian/source/format
183 test -e debian/rules || cp /usr/share/doc/debhelper/examples/rules.tiny debian/rules
184 cd - > /dev/null
185 }
186
187 buildsimplenativepackage() {
188 local NAME="$1"
189 local ARCH="$2"
190 local VERSION="$3"
191 local RELEASE="${4:-unstable}"
192 local DEPENDENCIES="$5"
193 local DESCRIPTION="$6"
194 local SECTION="${7:-others}"
195 local DISTSECTION
196 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
197 DISTSECTION="main"
198 else
199 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
200 fi
201 setupsimplenativepackage "$NAME" "$ARCH" "$VERSION" "$RELEASE" "$DEPENDENCIES" "$DESCRIPTION" "$SECTION"
202 buildpackage "incoming/${NAME}-${VERSION}" "$RELEASE" "$DISTSECTION"
203 rm -rf "incoming/${NAME}-${VERSION}"
204 }
205
206 buildpackage() {
207 local BUILDDIR=$1
208 local RELEASE=$2
209 local SECTION=$3
210 msgninfo "Build package $(echo "$BUILDDIR" | grep -o '[^/]*$') for ${RELEASE} in ${SECTION}… "
211 cd $BUILDDIR
212 if [ "$ARCH" = "all" ]; then
213 ARCH="$(dpkg-architecture -qDEB_HOST_ARCH 2> /dev/null)"
214 fi
215 local BUILT="$(dpkg-buildpackage -uc -us -a$ARCH 2> /dev/null)"
216 local PKGS="$( echo "$BUILT" | grep '^dpkg-deb: building package' | cut -d'/' -f 2 | sed -e "s#'\.##")"
217 local SRCS="$( echo "$BUILT" | grep '^dpkg-source: info: building' | grep -o '[a-z0-9._+~-]*$')"
218 cd - > /dev/null
219 for PKG in $PKGS; do
220 echo "pool/${PKG}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.pkglist
221 done
222 for SRC in $SRCS; do
223 echo "pool/${SRC}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.srclist
224 done
225 msgdone "info"
226 }
227
228 buildaptarchive() {
229 if [ -d incoming ]; then
230 buildaptarchivefromincoming $*
231 else
232 buildaptarchivefromfiles $*
233 fi
234 }
235
236 createaptftparchiveconfig() {
237 local ARCHS="$(find pool/ -name '*.deb' | grep -oE '_[a-z0-9-]+\.deb$' | sort | uniq | sed -e '/^_all.deb$/ d' -e 's#^_\([a-z0-9-]*\)\.deb$#\1#' | tr '\n' ' ')"
238 if [ -z "$ARCHS" ]; then
239 # the pool is empty, so we will operate on faked packages - let us use the configured archs
240 ARCHS="$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
241 fi
242 echo -n 'Dir {
243 ArchiveDir "' >> ftparchive.conf
244 echo -n $(readlink -f .) >> ftparchive.conf
245 echo -n '";
246 CacheDir "' >> ftparchive.conf
247 echo -n $(readlink -f ..) >> ftparchive.conf
248 echo -n '";
249 FileListDir "' >> ftparchive.conf
250 echo -n $(readlink -f pool/) >> ftparchive.conf
251 echo -n '";
252 };
253 Default {
254 Packages::Compress ". gzip bzip2 lzma";
255 Sources::Compress ". gzip bzip2 lzma";
256 Contents::Compress ". gzip bzip2 lzma";
257 };
258 TreeDefault {
259 Directory "pool/";
260 SrcDirectory "pool/";
261 };
262 APT {
263 FTPArchive {
264 Release {
265 Origin "joesixpack";
266 Label "apttestcases";
267 Suite "unstable";
268 Description "repository with dummy packages";
269 Architectures "' >> ftparchive.conf
270 echo -n "$ARCHS" >> ftparchive.conf
271 echo 'source";
272 };
273 };
274 };' >> ftparchive.conf
275 for DIST in $(find ./pool/ -maxdepth 1 -name '*.pkglist' -type f | cut -d'/' -f 3 | cut -d'.' -f 1 | sort | uniq); do
276 echo -n 'tree "dists/' >> ftparchive.conf
277 echo -n "$DIST" >> ftparchive.conf
278 echo -n '" {
279 Architectures "' >> ftparchive.conf
280 echo -n "$ARCHS" >> ftparchive.conf
281 echo -n 'source";
282 FileList "' >> ftparchive.conf
283 echo -n "${DIST}.\$(SECTION).pkglist" >> ftparchive.conf
284 echo -n '";
285 SourceFileList "' >> ftparchive.conf
286 echo -n "${DIST}.\$(SECTION).srclist" >> ftparchive.conf
287 echo -n '";
288 Sections "' >> ftparchive.conf
289 echo -n "$(find ./pool/ -maxdepth 1 -name "${DIST}.*.pkglist" -type f | cut -d'/' -f 3 | cut -d'.' -f 2 | sort | uniq | tr '\n' ' ')" >> ftparchive.conf
290 echo '";
291 };' >> ftparchive.conf
292 done
293 }
294
295 buildaptftparchivedirectorystructure() {
296 local DISTS="$(grep -i '^tree ' ftparchive.conf | cut -d'/' -f 2 | sed -e 's#".*##')"
297 for DIST in $DISTS; do
298 local SECTIONS="$(grep -i -A 5 "dists/$DIST" ftparchive.conf | grep -i 'Sections' | cut -d'"' -f 2)"
299 for SECTION in $SECTIONS; do
300 local ARCHS="$(grep -A 5 "dists/$DIST" ftparchive.conf | grep Architectures | cut -d'"' -f 2 | sed -e 's#source##')"
301 for ARCH in $ARCHS; do
302 mkdir -p dists/${DIST}/${SECTION}/binary-${ARCH}
303 done
304 mkdir -p dists/${DIST}/${SECTION}/source
305 mkdir -p dists/${DIST}/${SECTION}/i18n
306 done
307 done
308 }
309
310 insertpackage() {
311 local RELEASE="$1"
312 local NAME="$2"
313 local ARCH="$3"
314 local VERSION="$4"
315 local DEPENDENCIES="$5"
316 local ARCHS="$ARCH"
317 if [ "$ARCHS" = "all" ]; then
318 ARCHS="$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
319 fi
320 for BUILDARCH in $ARCHS; do
321 local PPATH="aptarchive/dists/${RELEASE}/main/binary-${BUILDARCH}"
322 mkdir -p $PPATH aptarchive/dists/${RELEASE}/main/source
323 touch aptarchive/dists/${RELEASE}/main/source/Sources
324 local FILE="${PPATH}/Packages"
325 echo "Package: $NAME
326 Priority: optional
327 Section: other
328 Installed-Size: 23356
329 Maintainer: Joe Sixpack <joe@example.org>
330 Architecture: $ARCH
331 Version: $VERSION" >> $FILE
332 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
333 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
334 If you find such a package installed on your system,
335 YOU did something horribly wrong! They are autogenerated
336 und used only by testcases for APT and surf no other propose…
337 " >> $FILE
338 done
339 }
340
341 buildaptarchivefromincoming() {
342 msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on incoming packages…"
343 cd aptarchive
344 [ -e pool ] || ln -s ../incoming pool
345 [ -e ftparchive.conf ] || createaptftparchiveconfig
346 [ -e dists ] || buildaptftparchivedirectorystructure
347 msgninfo "\tGenerate Packages, Sources and Contents files… "
348 aptftparchive -qq generate ftparchive.conf
349 cd - > /dev/null
350 msgdone "info"
351 generatereleasefiles
352 }
353
354 buildaptarchivefromfiles() {
355 msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on prebuild files…"
356 find aptarchive -name 'Packages' -o -name 'Sources' | while read line; do
357 msgninfo "\t${line} file… "
358 cat ${line} | gzip > ${line}.gz
359 cat ${line} | bzip2 > ${line}.bz2
360 cat ${line} | lzma > ${line}.lzma
361 msgdone "info"
362 done
363 generatereleasefiles
364 }
365
366 generatereleasefiles() {
367 msgninfo "\tGenerate Release files… "
368 if [ -e aptarchive/dists ]; then
369 for dir in $(find ./aptarchive/dists -mindepth 1 -maxdepth 1 -type d); do
370 local CODENAME="$(echo "$dir" | cut -d'/' -f 4)"
371 aptftparchive -qq release $dir -o APT::FTPArchive::Release::Codename="${CODENAME}" | sed -e '/0 Release$/ d' > $dir/Release # remove the self reference
372 if [ "$CODENAME" = "experimental" ]; then
373 sed -i '/^Date: / a\
374 NotAutomatic: yes' $dir/Release
375 fi
376 done
377 else
378 aptftparchive -qq release ./aptarchive | sed -e '/0 Release$/ d' > aptarchive/Release # remove the self reference
379 fi
380 msgdone "info"
381 }
382
383 setupdistsaptarchive() {
384 local APTARCHIVE=$(readlink -f ./aptarchive)
385 rm -f root/etc/apt/sources.list.d/apt-test-*-deb.list
386 rm -f root/etc/apt/sources.list.d/apt-test-*-deb-src.list
387 for DISTS in $(find ./aptarchive/dists/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 4); do
388 SECTIONS=$(find ./aptarchive/dists/${DISTS}/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 5 | tr '\n' ' ')
389 msgninfo "\tadd deb and deb-src sources.list lines for ${CCMD}${DISTS} ${SECTIONS}${CINFO}… "
390 echo "deb file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb.list
391 echo "deb-src file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb-src.list
392 msgdone "info"
393 done
394 }
395
396 setupflataptarchive() {
397 local APTARCHIVE=$(readlink -f ./aptarchive)
398 if [ -f ${APTARCHIVE}/Packages ]; then
399 msgninfo "\tadd deb sources.list line… "
400 echo "deb file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list
401 msgdone "info"
402 else
403 rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list
404 fi
405 if [ -f ${APTARCHIVE}/Sources ]; then
406 msgninfo "\tadd deb-src sources.list line… "
407 echo "deb-src file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list
408 msgdone "info"
409 else
410 rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list
411 fi
412 }
413
414 setupaptarchive() {
415 buildaptarchive
416 if [ -e aptarchive/dists ]; then
417 setupdistsaptarchive
418 else
419 setupflataptarchive
420 fi
421 signreleasefiles
422 msgninfo "\tSync APT's cache with the archive… "
423 aptget update -qq
424 msgdone "info"
425 }
426
427 signreleasefiles() {
428 local SIGNER="${1:-Joe Sixpack}"
429 msgninfo "\tSign archive with $SIGNER key… "
430 local SECKEYS=""
431 for KEY in $(find keys/ -name '*.sec'); do
432 SECKEYS="$SECKEYS --secret-keyring $KEY"
433 done
434 local PUBKEYS=""
435 for KEY in $(find keys/ -name '*.pub'); do
436 PUBKEYS="$PUBKEYS --keyring $KEY"
437 done
438 for RELEASE in $(find aptarchive/ -name Release); do
439 gpg --yes --no-default-keyring $SECKEYS $PUBKEYS --default-key "$SIGNER" -abs -o ${RELEASE}.gpg ${RELEASE}
440 done
441 msgdone "info"
442 }
443
444 changetowebserver() {
445 if which weborf > /dev/null; then
446 weborf -xb aptarchive/ 2>&1 > /dev/null &
447 CURRENTTRAP="kill $(ps | grep weborf | sed -e 's#^[ ]*##' | cut -d' ' -f 1); $CURRENTTRAP"
448 trap "$CURRENTTRAP" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
449 local APTARCHIVE="file://$(readlink -f ./aptarchive)"
450 for LIST in $(find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list'); do
451 sed -i $LIST -e "s#$APTARCHIVE#http://localhost:8080/#"
452 done
453 return 0
454 fi
455 return 1
456 }
457
458 checkdiff() {
459 local DIFFTEXT="$($(which diff) -u $* | sed -e '/^---/ d' -e '/^+++/ d' -e '/^@@/ d')"
460 if [ -n "$DIFFTEXT" ]; then
461 echo
462 echo "$DIFFTEXT"
463 return 1
464 else
465 return 0
466 fi
467 }
468
469 testfileequal() {
470 local FILE="$1"
471 shift
472 msgtest "Test for correctness of file" "$FILE"
473 if [ -z "$*" ]; then
474 echo -n "" | checkdiff $FILE - && msgpass || msgfail
475 else
476 echo "$*" | checkdiff $FILE - && msgpass || msgfail
477 fi
478 }
479
480 testequal() {
481 local COMPAREFILE=$(mktemp)
482 echo "$1" > $COMPAREFILE
483 shift
484 msgtest "Test for equality of" "$*"
485 $* 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
486 rm $COMPAREFILE
487 }
488
489 testequalor2() {
490 local COMPAREFILE1=$(mktemp)
491 local COMPAREFILE2=$(mktemp)
492 local COMPAREAGAINST=$(mktemp)
493 echo "$1" > $COMPAREFILE1
494 echo "$2" > $COMPAREFILE2
495 shift 2
496 msgtest "Test for equality OR of" "$*"
497 $* 2>&1 1> $COMPAREAGAINST
498 (checkdiff $COMPAREFILE1 $COMPAREAGAINST 1> /dev/null ||
499 checkdiff $COMPAREFILE2 $COMPAREAGAINST 1> /dev/null) && msgpass ||
500 ( echo "\n${CINFO}Diff against OR 1${CNORMAL}" "$(checkdiff $COMPAREFILE1 $COMPAREAGAINST)" \
501 "\n${CINFO}Diff against OR 2${CNORMAL}" "$(checkdiff $COMPAREFILE2 $COMPAREAGAINST)" &&
502 msgfail )
503 rm $COMPAREFILE1 $COMPAREFILE2 $COMPAREAGAINST
504 }
505
506 testshowvirtual() {
507 local VIRTUAL="N: Can't select versions from package '$1' as it purely virtual"
508 local PACKAGE="$1"
509 shift
510 while [ -n "$1" ]; do
511 VIRTUAL="${VIRTUAL}
512 N: Can't select versions from package '$1' as it purely virtual"
513 PACKAGE="${PACKAGE} $1"
514 shift
515 done
516 msgtest "Test for virtual packages" "apt-cache show $PACKAGE"
517 VIRTUAL="${VIRTUAL}
518 N: No packages found"
519 local COMPAREFILE=$(mktemp)
520 local ARCH=$(dpkg-architecture -qDEB_HOST_ARCH_CPU)
521 eval `apt-config shell ARCH APT::Architecture`
522 echo "$VIRTUAL" | sed -e "s/:$ARCH//" -e 's/:all//' > $COMPAREFILE
523 aptcache show -q=0 $PACKAGE 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
524 rm $COMPAREFILE
525 }
526
527 testnopackage() {
528 msgtest "Test for non-existent packages" "apt-cache show $*"
529 local SHOWPKG="$(aptcache show $* 2>&1 | grep '^Package: ')"
530 if [ -n "$SHOWPKG" ]; then
531 echo
532 echo "$SHOWPKG"
533 msgfail
534 return 1
535 fi
536 msgpass
537 }
538
539 testdpkginstalled() {
540 msgtest "Test for correctly installed package(s) with" "dpkg -l $*"
541 local PKGS="$(dpkg -l $* | grep '^[a-z]' | grep '^[^i]' | wc -l)"
542 if [ "$PKGS" != 0 ]; then
543 echo $PKGS
544 dpkg -l $* | grep '^[a-z]'
545 msgfail
546 return 1
547 fi
548 msgpass
549 }
550
551 testdpkgnoninstalled() {
552 msgtest "Test for correctly non-installed package(s) with" "dpkg -l $*"
553 local PKGS="$(dpkg -l $* | grep '^[a-z]' | grep '^[^u]' | wc -l)"
554 if [ "$PKGS" != 0 ]; then
555 echo
556 dpkg -l $* | grep '^[a-z]'
557 msgfail
558 return 1
559 fi
560 msgpass
561 }